var PanoPlaza = PanoPlaza || {};

PanoPlaza.Logger = function(api_url, shop_id, init_pano_id) {
                
    // common functions
    this.GuidNew = function() {
        var S4 = function() {
            return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
        };
        return (S4()+S4()+"-"+S4()+"-"+S4()+"-"+S4()+"-"+S4()+S4()+S4());
    };

    this.trace = function(s) {
        if (this.testmode === true) {
            try { console.log(s) } 
            catch (e) { 
//                alert(s) 
            }   
        }
    };
    
    // variables
    this.enabled = false;
    this.testmode = false;
    this.api_url = api_url;
    this.uid = this.GuidNew();
    this.virtualShopId = shop_id;
    this.currentPanoId = init_pano_id;
    this.panoLoadedAt = null;
    this.lastViewAtTime = null; // for 実験ログ
    this.lastViewAtPosX = null; // for 実験ログ
    this.lastViewAtPosY = null; // for 実験ログ

    this.eventIdTbl = {'loadShop' : '0', 
                    'loadPano' : '1', 
                    'unloadPano' : '2',
                    'clickItemSpot' : '3', 
                    'clickItemDetail' : '4', 
                    'clickItemTweet' : '5',
                    'clickPanoSpot' : '6', 
                    'clickFloorLink' : '7',
                    'zoomAt' : '8',
                    'viewAt' : '9' }; 
    var _this = this;
    
    // functions
    this.setTestmode = function() {
        this.testmode = true;
    }

    this.addLog = function(actionName, targetId, paramId)
    {      
        var eventId = this.eventIdTbl[actionName];
        var duration = "";
        var param = "";
    
        if (this.enabled === false) {
            return;
        }
        
        if (eventId === this.eventIdTbl['loadShop'])
        {
            param = navigator.userAgent;
            param += " ";
            param += $("body").width();
            param += "x";
            param += $("body").height();
        
            this.panoLoadedAt = new Date();
        }
        else if (eventId === this.eventIdTbl['loadPano'])
        {
            if (targetId != void 0) { // ショップロード時はtargetIdはundefined
                this.currentPanoId = targetId;           
            }
            this.panoLoadedAt = new Date();
        }
        else if (eventId === this.eventIdTbl['unloadPano'])
        {
            var now = new Date();
            duration = (now.getTime() - this.panoLoadedAt.getTime()) / 1000; // ミリ秒→秒
        }
        else {
            if (paramId != void 0) {
                param = paramId;
            }
        }
        
        var data = {uid: encodeURIComponent(this.uid), shopId: encodeURIComponent(this.virtualShopId), eventId: encodeURIComponent(eventId)};

        if (this.currentPanoId !== void 0) { // void 0 はundefinedを返す
            data.panoId = encodeURIComponent(this.currentPanoId)
        }      

        if (targetId !== void 0) { // void 0 はundefinedを返す
            data.targetId = encodeURIComponent(targetId);
        }

        if (duration !== "") {
            data.duration = encodeURIComponent(duration);
        }

        if (param !== "")
        {
            data.param = encodeURIComponent(param);
        }

        if (this.testmode === true) {
            data.testmode = true;
        }
             
        this.putData(JSON.stringify(data)); 
    };

    this.addLogX = function(actionName, hlookat, vlookat, hfov, vfov)
    {
        var x = "";
        var y = "";
        var duration = "";
        var param = "";
        var eventId = this.eventIdTbl[actionName];

        if (this.enabled === false) {
            return;
        }
        
        if (eventId === this.eventIdTbl['zoomAt'])
        {
            x = hlookat;
            y = vlookat;
            param = hfov + "," + vfov;
        }
        else if (eventId === this.eventIdTbl['viewAt'])
        {
            var now = new Date();

            if (this.lastViewAtTime === null) {
                this.lastViewAtTime = now;
                this.lastViewAtPosX = hlookat;
                this.lastViewAtPosY = vlookat;
                return;
            }

            duration = (now.getTime() - this.lastViewAtTime.getTime()) / 1000; // ミリ秒→秒
            this.lastViewAtTime = now;

            if (this.lastViewAtPosX !== null && this.lastViewAtPosY !== null) {
                x = this.lastViewAtPosX;
                y = this.lastViewAtPosY;
            }

            this.lastViewAtPosX = hlookat;
            this.lastViewAtPosY = vlookat;

            if (duration < 10) { // 有意でない場合（とりあえず10秒以上を閾値とする）はログに残さない
                return;
            }
        }

        var data = {uid: encodeURIComponent(this.uid), shopId: encodeURIComponent(this.virtualShopId), eventId: encodeURIComponent(eventId)};
       
        if (this.currentPanoId !== null) { // void 0 はundefinedを返す
            data.panoId = encodeURIComponent(this.currentPanoId)
        }

        if (x !== "")
        {
            data.x = encodeURIComponent(x);
        }

        if (y !== "")
        {
            data.y = encodeURIComponent(y);
        }

        if (duration !== "")
        {
            data.duration = encodeURIComponent(duration);
        }

        if (param !== "")
        {
            data.param =  encodeURIComponent(param);
        }

        if (this.testmode === true) {
            data.testmode = true;
        }

        this.putData(JSON.stringify(data)); 
    };
    
    this.putData = function(json) {  
        if (this.api_url !== null) {
            this.trace("putlog=" + json);
            if (this.testmode === false) {
                $.ajax({
                    type: "POST",        
                    url: this.api_url,
                    data: "action=create&data=" + json,
                    dataType: "json",
                    success: function(data){
                        _this.trace("response=" + data);                    
                    }
                });
            }
        }       
    };
    
    this.start = function(option) {
        this.enabled = true;
        this.addLog('loadShop');
        if (typeof(option) === 'undefined' || option.loadpano === true || option.loadpano !== false) { // for compatiblity with older version
            this.addLog('loadPano');            
        }       
    };   
}

$("body").ready(function(){
    $(window).unload(function(event){
        if (event.target.nodeName === "#document") {
            if (typeof(PanoPlaza.logger) !== 'undefined') {
                PanoPlaza.logger.addLog("unloadPano");  
            }            
        }
    });    
});

// for compatibility with old logger
function AddLog(actionName, targetId, paramId)
{   
    if (typeof(PanoPlaza.logger) !== 'undefined') {
        PanoPlaza.logger.addLog(actionName, targetId, paramId);    
    }
}

function AddLogX(actionName, hlookat, vlookat, hfov, vfov)
{
    if (typeof(PanoPlaza.logger) !== 'undefined') {
        PanoPlaza.logger.addLogX(actionName, hlookat, vlookat, hfov, vfov)        
    }
}